sum max(hdu 1003)

观察可以发现,0,1,2,……,n结尾的分组中,

maxsum
a[0] = a[0]

maxsum
a[1] = max( a[0] + a[1] ,a[1])  = max( maxsum a[0] + a[1]
,a[1])

maxsum
a[2] = max( max ( a[0] + a[1] + a[2],a[1] + a[2] ),a[2])

= max(  max( a[0] + a[1] ,a[1]) + a[2] , a[2])

= max(  maxsum a[1] + a[2] , a[2])

……

依此类推,可以得出通用的式子。

maxsum
a[i] = max(maxsum a[i-1] + a[i],a[i])


//#define LOCAL
#include<cstdio>
const int INF=-1000000;
int sum,sum_max,begin,end,temp,T,N,conn;
void solve()
{
scanf("%d",&N);
int a;
sum_max=INF,sum=0,temp=1,begin=1;
for(int i=0;i<N;i++)
{
scanf("%d",&a);
sum=sum+a;
if(sum_max<sum)
{
sum_max=sum;
begin=temp;
end=i+1;
}
if(sum<0)
{
sum=0;
temp=i+2;
}
}
printf("Case %d:\n%d %d %d\n",(conn-T),sum_max,begin,end);
if(T!=0)
{
printf("\n");
}
}
int main()
{
#ifdef LOCAL
freopen("1003.in","r",stdin);
freopen("1003.out","w",stdout);
#endif
scanf("%d",&T);
conn=T;
while(T--)
{
solve();
}
return 0;
}

Max Sum


Time
Limit: 2000/1000 MS (Java/Others)    Memory Limit:
65536/32768 K (Java/Others)
Total Submission(s):
136354    Accepted Submission(s):
31568

Problem Description

Given a sequence a[1],a[2],a[3]......a[n], your job
is to calculate the max sum of a sub-sequence. For example, given
(6,-1,5,4,-7), the max sum in this sequence is 6 + (-1) + 5 + 4 = 14.

Input

The first line of the input contains an integer
T(1<=T<=20) which means the number of test cases. Then T lines follow,
each line starts with a number N(1<=N<=100000), then N integers
followed(all the integers are between -1000 and 1000).

Output

For each test case, you should output two lines. The
first line is "Case #:", # means the number of the test case. The second line
contains three integers, the Max Sum in the sequence, the start position of the
sub-sequence, the end position of the sub-sequence. If there are more than one
result, output the first one. Output a blank line between two cases.

Sample Input

2 5 6 -1 5 4 -7 7 0 6
-1 1 -6 7 -5

Sample Output

Case 1: 14 1 4 Case 2:
7 1 6

Author

Ignatius.L

sum max(hdu 1003)

时间: 2024-11-05 18:22:32

sum max(hdu 1003)的相关文章

Max Sum (hdu 1003 简单DP水过)

Max Sum Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 161294    Accepted Submission(s): 37775 Problem Description Given a sequence a[1],a[2],a[3]......a[n], your job is to calculate the max s

HDU - 1003 - Max Sum &amp;&amp; POJ - 1050 - To the Max (经典DP问题)

题目传送:HDU - 1003 思路:最大子序列和 dp[i]= a[i]   (dp[i-1]<0) dp[i]= dp[i-1]+a[i]   (dp[i-1]>=0) AC代码: #include <cstdio> #include <cstring> #include <iostream> #include <algorithm> #include <cmath> #include <queue> #include

HDU 1003 Max Sum 最大连续子序列的和

Problem Description Given a sequence a[1],a[2],a[3]......a[n], your job is to calculate the max sum of a sub-sequence. For example, given (6,-1,5,4,-7), the max sum in this sequence is 6 + (-1) + 5 + 4 = 14. Input The first line of the input contains

HDU 1003:Max Sum(DP)

Max Sum Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 142742    Accepted Submission(s): 33225 Problem Description Given a sequence a[1],a[2],a[3]......a[n], your job is to calculate the max s

[ACM] hdu 1003 Max Sum(最大子段和模型)

Max Sum Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 135262    Accepted Submission(s): 31311 Problem Description Given a sequence a[1],a[2],a[3]......a[n], your job is to calculate the max s

HDU 1003 Max Sum(dp,最大连续子序列和)

Max Sum Problem Description Given a sequence a[1],a[2],a[3]......a[n], your job is to calculate the max sum of a sub-sequence. For example, given (6,-1,5,4,-7), the max sum in this sequence is 6 + (-1) + 5 + 4 = 14. Input The first line of the input

HDU 1003 Max Sum (动规)

Max Sum Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 141547    Accepted Submission(s): 32929 Problem Description Given a sequence a[1],a[2],a[3]......a[n], your job is to calculate the max s

HDU 1003 Max Sum(DP)

题目地址:HDU 1003 DP好弱..先补补DP的基础... 这题就是记录起始点与终止点,然后每当发现一个更大的,就更新.从左往右扫一遍就行了. 代码如下: #include <iostream> #include <cstdio> #include <string> #include <cstring> #include <stdlib.h> #include <math.h> #include <ctype.h> #

HDU 1003 Max Sum

题目: Problem Description Given a sequence a[1],a[2],a[3]......a[n], your job is to calculate the max sum of a sub-sequence. For example, given (6,-1,5,4,-7), the max sum in this sequence is 6 + (-1) + 5 + 4 = 14. Input The first line of the input cont